﻿using System;
using System.Drawing;
using System.Xml.Linq;
using CloudShot.Core.Types;

namespace CloudShot.Core.Interfaces
{
	/// <summary>
	/// Exposes the image storage.
	/// </summary>
	public interface IImageStorage
	{
		#region Properties

		Image Logo { get; }
		string Name { get; }
		string Description { get; }

		AuthorizationMode AuthorizationMode { get; }

		ImageSaveFormat[] SupportedFormats { get; }
		ImageSaveFormat CurrentImageFormat { get; set; }

		StorageType SupportedStorageType { get; }
		string FolderToSave { get; set; }

		string OAuthTokens { get; set; }
		bool IsAuthorized { get; }

		#endregion

		#region Methods

		ShotInfo SaveImageAsync(Image image, string name, Action<ShotInfo> uploadCompleted);

		void SignInAsync(Action<bool> callback);
		void SignOut();//=Cancel Waiting of Auth

		XElement[] SaveSettings();
		void LoadSettings(XElement[] settings);

		#endregion
	}
}