﻿namespace CloudShot.Core.Types
{
	/// <summary>
	/// Specifies image storage types.
	/// </summary>
	public enum StorageType
	{
		/// <summary>
		/// Local storage with fixed folder path to save files.
		/// </summary>
		Local,
		
		/// <summary>
		/// Local storage with custom folder path to save files.
		/// </summary>
		CustomLocal,
		
		/// <summary>
		/// Remote storage with fixed folder path to save files.
		/// </summary>
		Remote,

		/// <summary>
		/// Remote storage with custom folder path to save files.
		/// </summary>
		CustomRemote
	}
}